package com.vendor.platform.api.statistics;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import org.eclipse.ui.WorkbenchEncoding;

public class ToolStatistics {
  private static final String STAT_FILE_EXT = ".std";
  
  private static final String TEXT_BRK_LEFT = "[";
  
  private static final String TEXT_BRK_RIGHT = "]";
  
  private static final String TEXT_BRK_SPACE = " ";
  
  private static final String TEXT_ENDLINE = "\r\n";
  
  private static final String TEXT_SEPARATOR = "|";
  
  private static final String TEXT_NO_PARAMS = "NULL";
  
  private static final String TEXT_USE_START = "USE_START";
  
  private static final String TEXT_USE_STILL = "USE_STILL";
  
  private static final String TEXT_USE_FINISH = "USE_FINISH";
  
  public static final com.vendor.platform.api.statistics.ToolStatistics INSTANCE = new com.vendor.platform.api.statistics.ToolStatistics();
  
  protected synchronized void appendFile(String toolName, String statText) {
    if (toolName == null || toolName.isEmpty())
      return; 
    String dirPath = "";
    File dir = new File(dirPath);
    if (!dir.exists() && 
      !dir.mkdirs())
      return; 
    StringBuffer sb = new StringBuffer();
    sb.append("[");
    SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    sb.append(df.format(new Date()));
    sb.append("]");
    sb.append(" ");
    sb.append(statText);
    sb.append("\r\n");
    char[] textChars = sb.toString().toCharArray();
    String filePath = dirPath + dirPath + ".std";
    File file = new File(filePath);
    FileOutputStream stream = null;
    BufferedWriter writer = null;
    try {
      stream = new FileOutputStream(file, true);
      writer = new BufferedWriter(new OutputStreamWriter(stream, WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      writer.write(textChars);
    } catch (IOException e) {
      e.printStackTrace();
      return;
    } finally {
      if (writer != null)
        try {
          writer.close();
        } catch (IOException e) {
          e.printStackTrace();
        }  
      if (stream != null)
        try {
          stream.close();
        } catch (IOException e) {
          e.printStackTrace();
        }  
    } 
  }
  
  public void logToolStart(String toolName) {
    appendFile(toolName, "USE_START");
  }
  
  public void logToolInUse(String toolName) {
    appendFile(toolName, "USE_STILL");
  }
  
  public void logToolFinish(String toolName) {
    appendFile(toolName, "USE_FINISH");
  }
  
  public void logUsage(String toolName, String function, String params) {
    StringBuilder sb = new StringBuilder();
    sb.append(function);
    sb.append("|");
    if (params == null || params.isEmpty()) {
      sb.append("NULL");
    } else {
      sb.append(params);
    } 
    appendFile(toolName, sb.toString());
  }
}
